# Notes:
# 	- upstream maintainer Adrian Bunk <bunk@kernel.org>

%define name util-linux
%define version 2.13
%define pre 7
%define release %mkrel 0.pre%{pre}.6
%define oversion %{version}-pre%{pre}
%define distname %{name}-%{oversion}

### Features
%define include_raw 1

Summary:	A collection of basic system utilities
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPL
Group:		System/Base
URL:		ftp://ftp.kernel.org/pub/linux/utils/util-linux/
### Sources
Source0:	ftp://ftp.kernel.org/pub/linux/utils/util-linux/%{distname}.tar.bz2
# based on Fedora pam files, with pam_selinux stripped out
Source1:	util-linux-login.pamd
Source2:	util-linux-remote.pamd
Source3:	util-linux-chsh-chfn.pamd
Source4:	util-linux-60-raw.rules
Source8:	nologin.c
Source9:	nologin.8

BuildRequires:	gcc
BuildRequires:	sed
BuildRequires:	e2fsprogs-devel
BuildRequires:	gettext-devel
BuildRequires:	pam-devel
BuildRequires:	ncurses-devel
BuildRequires:	termcap-devel
BuildRequires:	texinfo
BuildRequires:	slang-devel
BuildRequires:	zlib-devel
BuildRequires:	libaudit-devel

### Patches
# Note on how to set up raw device mappings using RHL /etc/sysconfig/rawdevices
Patch109: util-linux-2.11f-rawman.patch

Patch100: util-linux-2.12j-managed.patch

Patch106: util-linux-2.12p-swaponsymlink-57300.patch
Patch107: util-linux-2.11y-procpartitions-37436.patch
Patch113: util-linux-2.13-ctty3.patch

Patch120: util-linux-2.11y-skipraid2.patch
Patch126: util-linux-2.11y-multibyte.patch
Patch128: util-linux-2.12a-ipcs-84243-86285.patch

Patch138: util-linux-2.11y-chsh-103004.patch
Patch139: util-linux-2.11y-fdisksegv-103954.patch

Patch147: util-linux-2.12a-126572-fdiskman.patch

Patch151: util-linux-2.12a-mountbylabel-dm.patch
Patch153: util-linux-2.12a-16415-rdevman.patch

# Patch to enabled remote service for login/pam (#91174)
Patch157: util-linux-2.12a-pamstart.patch
# Patch to enable the pamconsole flag for restricting mounting to users at the console (#133941)
Patch159: util-linux-2.12j-pamconsole.patch
# Allow raw(8) to bind raw devices whose device nodes do not yet exist.
Patch160: raw-handle-nonpresent-devs.patch

Patch164: util-linux-2.12j-113790-hotkeys.patch

# Info about NFS4
Patch170: util-linux-2.13-mount-man-nfs4.patch
# Makeing /var/log/lastlog (#151635)
Patch180: util-linux-2.12p-login-lastlog.patch
# Improved /etc/mtab lock (#143118)
Patch181: util-linux-2.12p-mtab-lock.patch
# Stupid typo (#151156)
Patch182: util-linux-2.12p-ipcs-typo.patch
# 154498 - util-linux login & pam session
Patch183: util-linux-2.12a-pamsession.patch
# 76467 - At boot time, fsck chokes on LVs listed by label in fstab
Patch185: util-linux-2.12p-lvm2dupes-76467.patch
# add note about ATAPI IDE floppy to fdformat.8
Patch186: util-linux-2.12p-fdformat-ide.patch
# 145355 - Man pages for fstab and fstab-sync in conflict.
Patch187: util-linux-2.12p-fstab-man.patch
# 156597 - look - doesn't work with separators
Patch188: util-linux-2.12p-look-separator.patch
# 157656 - CRM 546998 : Possible bug in vipw, changes permissions of /etc/shadow
Patch189: util-linux-2.12p-vipw-perm.patch
# 159339 - util-linux updates for new audit system
Patch202: util-linux-2.13-audit-hwclock.patch
# 158737 - sfdisk warning for large partitions, gpt
Patch203: util-linux-2.13-fdisk-gpt.patch
# 150912 - Add ocfs2 support
Patch204: util-linux-2.12p-mount-ocfs2.patch
# NULL is better than zero at end of execl()
Patch205: util-linux-2.12p-execl.patch
# deprecated the arch command (for compatibility only)
Patch206: util-linux-2.13-arch.patch
# 165863 - swsusp swaps should be reinitialized
Patch210: util-linux-2.13-swapon-suspend.patch
# 170110 - Documentation for 'rsize' and 'wsize' NFS mount options is misleading
Patch211: util-linux-2.13-mount-man-nfs.patch
# 168436 - login will attempt to run if it has no read/write access to its terminal
# 168434 - login's timeout can fail - needs to call siginterrupt(SIGALRM,1)
Patch213: util-linux-2.13-login-hang.patch
# 165253 - losetup missing option -a [new feature]
Patch214: util-linux-2.13-losetup-all.patch
# 170564 - add audit message to login
Patch215: util-linux-2.13-audit-login.patch
# 170171 - ipcs -lm always report "max total shared memory (kbytes) = 0"
Patch216: util-linux-2.13-ipcs-shmax.patch
# 171337 - mkfs.cramfs dies creating installer image
Patch217: util-linux-2.13-cramfs-maxentries.patch
# [also 171337] - mkfs.cramfs doesn't work correctly with empty files
Patch218: util-linux-2.13-cramfs-zerofiles.patch
# 172203 - mount man page in RHEL4 lacks any info on cifs mount options
Patch219: util-linux-2.12a-mount-man-cifs.patch
# better wide chars usage in the cal command (based on the old 'moremisc' patch)
Patch220: util-linux-2.12p-cal-wide.patch
# 176441: col truncates data
Patch221: util-linux-2.12p-col-EILSEQ.patch
# 174111 - mount allows loopback devices to be mounted more than once to the same mount point
Patch222: util-linux-2.13-mount-twiceloop.patch
# nobug - add --rmpart N and --rmparts
Patch223: util-linux-2.13-rmparts.patch
# 181782 - mkswap should automatically add selinux label to swapfile
Patch224: util-linux-2.13-mkswap-selinux.patch
# 181896 - broken example in man pages
Patch225: util-linux-2.13-schedutils-man.patch
# 177331 - login omits pam_acct_mgmt & pam_chauthtok when authentication is skipped.
Patch226: util-linux-2.13-login-pam-acct.patch
# 177523 - umount -a should not unmount sysfs
Patch227: util-linux-2.13-umount-sysfs.patch
# 187014 - umount segfaults for normal user
Patch233: util-linux-2.13-mount-uuid.patch
# 183446 - cal not UTF-8-aware
Patch234: util-linux-2.13-cal-wide.patch
# 186915 - mount does not translate SELIinux context options though libselinux
# 185500 - Need man page entry for -o context= mount option
# 211827 - Can't mount with additional contexts
Patch235: util-linux-2.13-mount-context.patch
# 152579 - missing info about /etc/mtab and /proc/mounts mismatch
# 183890 - missing info about possible ioctl() and fcntl() problems on NFS filesystem
Patch236: util-linux-2.13-mount-man-bugs.patch
# Keep gcc happy
Patch237: util-linux-2.13-hexdump-gcc.patch
# 191230 - using mount --move results in wrong data in /etc/mtab
Patch238: util-linux-2.13-mount-move.patch
# Subtrees support
Patch239: util-linux-2.13-mount-subtree.patch
# wrong number of sectors for large disks (suse#160822)
Patch240: util-linux-2.13-fdisk-sectors.patch
# 182553 - fdisk -l inside xen guest shows no disks
# 188981 - "sfdisk -l" tries to open partitions
Patch241: util-linux-2.13-fdisk-isfull.patch
# 181549 - raw(8) manpage has old information about dd
Patch242: util-linux-2.12a-raw-man-dd.patch
# Don't use asm/page.h
Patch243: util-linux-2.13-swap-page.patch
# IPv6 support to login command
Patch245: util-linux-2.13-login-ipv6.patch
# 176494 - last -i returns strange IP addresses
Patch247: util-linux-2.13-login-timeval.patch
# 199745 - Non-existant simpleinit(8) mentioned in ctrlaltdel(8)
Patch248: util-linux-2.13-ctrlaltdel-man.patch
# 205038 - mount not allowing sloppy option
Patch249: util-linux-2.13-mount-sloppy.patch
# 188193 - util-linux should provide plugin infrastructure for HAL
Patch250: util-linux-2.13-mount-uhelper.patch
# Removes obsolete NFS code (we use /sbin/[u]mount.nfs[4] from nfs-utils)
Patch251: util-linux-2.13-mount-nonfs.patch
# Losetup.8 update -- add info about dm-crypt
Patch252: util-linux-2.13-losetup-deprecated.patch
# 208634 - mkswap "works" without warning on a mounted device
Patch253: util-linux-2.13-mkswap-mounted.patch
# 213127 - mount --make-unbindable does not work
Patch254: util-linux-2.13-mount-comment.patch
# 211749 - add -r option to losetup to create a read-only loop
Patch255: util-linux-2.13-losetup-rdonly.patch
# 216489 - SCHED_BATCH option missing in chrt
Patch256: util-linux-2.13-schedutils-SCHED_BATCH.patch
# 216712 - issues with raw device support ("raw0" is wrong device name)
Patch257: util-linux-2.13-raw-raw0.patch
# 217186 - /bin/sh: @MKINSTALLDIRS@: No such file or directory
Patch258: util-linux-2.13-mkdir_p.patch
# 218915 - fdisk -b 4K
Patch259: util-linux-2.13-fdisk-b-4096.patch
# leaking file descriptor
Patch260: util-linux-2.13-more-CLOEXEC.patch
# 217240 - namei ignores non-directory components instead of saying "Not a directory"
# 217241 - namei enforces symlink limits inconsistently
Patch261: util-linux-2.13-namei-logic.patch
# 222293 - undocumented partx,addpart, delpart
Patch262: util-linux-2.13-partx-man.patch
# 150493 - hwclock --systohc sets clock 0.5 seconds slow
Patch263: util-linux-2.13-hwclock-systohc.patch
# 227903 - mount -f does not work with NFS-mounted
Patch264: util-linux-2.13-mount-fake.patch
# 243930 - Translation files exist, but are not being used
Patch265: util-linux-2.13-localedir.patch
# 228731 - sfdisk doesn't support DM-MP device (add default heads and sectors)
Patch266: util-linux-2.13-sfdisk-geo.patch
# 231192 - ipcs is not printing correct values on pLinux
Patch267: util-linux-2.13-ipcs-32bit.patch
# 245912: mount doesn't write the 'loop=...' option in /etc/mtab when mounting a loop device
Patch268: util-linux-2.13-mount-loop.patch
# 213253: "cal -3" generates improperly formatted output
Patch269: util-linux-2.13-cal-3.patch

# When adding patches, please make sure that it is easy to find out what bug # the 
# patch fixes.
########### END upstreamable

### Patches merged upstream (in util-linux-ng)
# relatime support, rediffed from Valerie Henson's patch
Patch500: util-linux-2.13-pre7-relatime.patch
Patch501: util-linux-2.13-pre7-mkswap-uuid.patch

### Mandriva Specific patches

# misc documentation fixes for man pages
Patch70:	util-linux-2.12q-miscfixes.patch
Patch111: util-linux-2.11t-mkfsman.patch
Patch114: util-linux-2.11t-dumboctal.patch
Patch115: util-linux-2.12q-fix-ioctl.patch
Patch116: util-linux-2.12q-autodav.patch
Patch201: util-linux-2.11m-nolock-docs.patch

# crypto patches
# rediffed from http://loop-aes.sourceforge.net/updates/util-linux-2.13-pre7-2.diff.bz2
Patch1100: util-linux-2.13-pre7-loopAES.patch
Patch1101: util-linux-2.12q-swapon-skip-encrypted.patch
Patch1102: util-linux-2.12-lower-LOOP_PASSWORD_MIN_LENGTH-for-AES.patch
# load cryptoloop and cypher modules when use cryptoapi
Patch1103: util-linux-2.12a-cryptoapi-load-module.patch
Patch1104: util-linux-2.13-pre7-set-as-encrypted.patch

# clock program for ppc
Patch1200:	util-linux-2.10r-clock-1.1-ppc.patch
# leng options for clock-ppc
Patch1201:	util-linux-2.10s-clock-syntax-ppc.patch
# Added r & w options to chfn (lsb mandate)
Patch1202:	util-linux-2.11o-chfn-lsb-usergroups.patch
# fix build on alpha with newer kernel-headers
Patch1203:	util-linux-2.11m-cmos-alpha.patch
# handle biarch struct ll_time
Patch1206:	util-linux-2.13-pre7-biarch-ll_time.patch
# do not hide users option in mtab
Patch1207:	util-linux-2.13-pre7-users.patch
# Try to detect if the cdrom we have is a cd-extra (track audio and later track data) not
Patch1210:	util-linux-2.13-pre7-mount_guess_fs_cdextra.patch
# (peroyvind) fixes for sparc
Patch1212:	util-linux-2.12r-sparc.patch
# fdisk: reread partition table on block devices only
Patch1215:		util-linux-2.12r-rereadpt.patch
# remove mode= from udf mounts (architecture done so that more may come)
Patch1218: util-linux-2.12q-mount-remove-silly-options-in-auto.patch

# Mandrakemove patches
Patch1300: 	util-linux-2.12q-losetup-try-LOOP_CHANGE_FD-when-loop-already-busy.patch

Obsoletes:	fdisk tunelp schedutils
Provides: fdisk tunelp schedutils
%ifarch alpha %{sunsparc} ppc
Obsoletes:	clock
%endif

BuildRoot:	%{_tmppath}/%{name}-%{version}-root
%if %{include_raw}
Requires: udev
%endif
Requires:	%{_lib}consolekit
Requires:	pam >= 0.66-4, shadow-utils >= 4.0.3
Requires(pre):	mktemp /bin/awk /usr/bin/cmp coreutils
Requires(post):	info-install
Requires(preun):	info-install
%description
The util-linux package contains a large variety of low-level system
utilities that are necessary for a Linux system to function.  Among
others, Util-linux contains the fdisk configuration tool and the
login program.

%package -n mount
Summary: Programs for mounting and unmounting filesystems
Group: System/Base

%description -n mount
The mount package contains the mount, umount, swapon and swapoff
programs.  Accessible files on your system are arranged in one big
tree or hierarchy.  These files can be spread out over several
devices. The mount command attaches a filesystem on some device to
your system's file tree.  The umount command detaches a filesystem
from the tree.  Swapon and swapoff, respectively, specify and disable
devices and files for paging and swapping.

%package -n losetup
Summary: Programs for setting up and configuring loopback devices
Group: System/Configuration/Networking

%description -n losetup
Linux supports a special block device called the loop device, which
maps a normal file onto a virtual block device.  This allows for the
file to be used as a "virtual file system" inside another file.
Losetup is used to associate loop devices with regular files or block
devices, to detach loop devices and to query the status of a loop
device.

%prep

%setup -q -n %{distname}

# nologin
cp %{SOURCE8} %{SOURCE9} .
%patch100 -p1
%patch106 -p1
%patch107 -p1
%patch109 -p1
%patch113 -p1
%patch120 -p1
%patch126 -p1
%patch128 -p1
%patch138 -p1
%patch139 -p1
%patch147 -p1
%patch151 -p1
%patch153 -p1
%patch157 -p1
%patch159 -p1
%patch160 -p1
%patch164 -p1
%patch170 -p1
%patch180 -p1
%patch181 -p1
%patch182 -p1
%patch183 -p1
%patch185 -p1
%patch186 -p1
%patch187 -p1
%patch188 -p1
%patch189 -p1
%patch202 -p1
%patch203 -p1
%patch204 -p1
%patch205 -p1
%patch206 -p1
%patch210 -p1
%patch211 -p1
%patch213 -p1
# (blino) already in loop-AES
#%patch214 -p1
%patch215 -p1
%patch216 -p1
%patch217 -p1
%patch218 -p1
%patch219 -p1
%patch220 -p1
%patch221 -p1
%patch222 -p1
%patch223 -p1
%patch224 -p1
%patch225 -p1
%patch226 -p1
%patch227 -p1
%patch233 -p1
%patch234 -p1
%patch235 -p1
%patch236 -p1
%patch237 -p1
%patch238 -p1
%patch239 -p1
%patch240 -p1
%patch241 -p1
%patch242 -p1
%patch243 -p1
%patch245 -p1
%patch247 -p1
%patch248 -p1
%patch249 -p1
%patch250 -p1
%patch251 -p1
%patch252 -p1
%patch253 -p1
%patch254 -p1
# (blino) already in loop-AES
#%patch255 -p1
%patch256 -p1
%patch257 -p1
%patch258 -p1
%patch259 -p1
%patch260 -p1
%patch261 -p1
%patch262 -p1
%patch263 -p1
%patch264 -p1
%patch265 -p1
%patch266 -p1
%patch267 -p1
%patch268 -p1
%patch269 -p1

%patch500 -p1 -b .relatime
%patch501 -p1 -b .mkswapuuid

# Mandriva 
%patch70 -p1 -b .miscfixes

%ifarch ppc
%patch1200 -p0
%patch1201 -p1
%endif

#LSB (sb)
%patch1202 -p1

#fix build on alpha with newer kernel-headers
%ifarch alpha
%patch1203 -p1
%endif

%patch1206 -p1 -b .biarch-ll_time

%patch111 -p1 -b .mkfsman                                                      
%patch114 -p1 -b .dumboctal
%patch115 -p1 -b .fix-ioctl
%patch116 -p1 -b .autodav
%patch201 -p1 -b .docbug

%patch1100 -p1 -b .loopAES
%patch1101 -p1 -b .swapon-encrypted
%patch1102 -p1 -b .loopAES-password
%patch1103 -p1 -b .load-module
%patch1104 -p1 -b .encrypted

%patch1300 -p1 -b .CHANGE-FD

%patch1207 -p1 -b .users
%patch1210 -p1 -b .cdextra
%patch1212 -p1 -b .sparc
%patch1215 -p1 -b .rereadpt
%patch1218 -p1 -b .silly

%build
%serverbuild
unset LINGUAS || :

# rebuild build system
aclocal
automake -a
autoconf

# CFLAGS
%define make_cflags -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64

# note: we install to /bin and /usr/bin, so there's $bindir and $usrbindir in
# util-linux build system. It's better follow package build-system than rpm
# macros (where is prefix=/usr)
%define _prefix	""

# configure
# note: we disable tty group (USE_TTY_GROUP) in Makefiles to prevent call chgrp 
# during the "make install". But we define -DUSE_TTY_GROUP that enable tty groups in
# *.c files only.
export CFLAGS="%{make_cflags} -DUSE_TTY_GROUP $RPM_OPT_FLAGS"
%configure \
	--disable-wall \
	--disable-use-tty-group \
	--enable-partx \
	--enable-login-utils \
	--enable-kill \
	--enable-write \
%if %{include_raw}
	--enable-raw \
%endif
	--enable-rdev

# reset to original 
%define _prefix	/usr

# build util-linux
make %{?_smp_mflags}

# build nologin
gcc $RPM_OPT_FLAGS -o nologin nologin.c

%ifarch ppc
gcc clock-ppc.c -o clock-ppc
%endif

# build docs
pushd sys-utils
    makeinfo --number-sections ipc.texi
popd

%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}/{bin,sbin}
mkdir -p ${RPM_BUILD_ROOT}%{_bindir}
mkdir -p ${RPM_BUILD_ROOT}%{_infodir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man{1,6,8,5}
mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/{pam.d,security/console.apps}

# install util-linux
make install DESTDIR=$RPM_BUILD_ROOT MANDIR=%buildroot/%{_mandir} INFODIR=%buildroot/%{_infodir}

# install no login
install -m 755 nologin ${RPM_BUILD_ROOT}/sbin
install -m 644 nologin.8 ${RPM_BUILD_ROOT}%{_mandir}/man8

%if %{include_raw}
echo '.so man8/raw.8' > $RPM_BUILD_ROOT%{_mandir}/man8/rawdevices.8
{ 
  # see RH bugzilla #216664
  mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/udev/rules.d
  pushd ${RPM_BUILD_ROOT}%{_sysconfdir}/udev/rules.d
  install -m 644 %{SOURCE4} ./60-raw.rules
  popd
}
%endif

# Correct mail spool path.
perl -pi -e 's,/usr/spool/mail,/var/spool/mail,' ${RPM_BUILD_ROOT}%{_mandir}/man1/login.1

%ifarch %{sunsparc}
rm -rf ${RPM_BUILD_ROOT}%{_bindir}/sunhostid
cat << E-O-F > ${RPM_BUILD_ROOT}%{_bindir}/sunhostid
#!/bin/sh
# this should be %{_bindir}/sunhostid or somesuch.
# Copyright 1999 Peter Jones, <pjones@redhat.com> .  
# GPL and all that good stuff apply.
(
idprom=\`cat /proc/openprom/idprom\`
echo \$idprom|dd bs=1 skip=2 count=2
echo \$idprom|dd bs=1 skip=27 count=6
echo
) 2>/dev/null
E-O-F
chmod 755 ${RPM_BUILD_ROOT}%{_bindir}/sunhostid
%endif

#gzip -9nf ${RPM_BUILD_ROOT}%{_infodir}/ipc.info

# PAM settings
{ 
  pushd ${RPM_BUILD_ROOT}%{_sysconfdir}/pam.d
  install -m 644 %{SOURCE1} ./login
  install -m 644 %{SOURCE2} ./remote
  install -m 644 %{SOURCE3} ./chsh
  install -m 644 %{SOURCE3} ./chfn
  popd
}

# This has dependencies on stuff in /usr
mv $RPM_BUILD_ROOT{/sbin/,/usr/sbin}/cfdisk

%ifarch ppc
cp -f ./clock-ppc $RPM_BUILD_ROOT/sbin/clock-ppc
mv $RPM_BUILD_ROOT/sbin/hwclock $RPM_BUILD_ROOT/sbin/clock-rs6k
ln -sf clock-rs6k $RPM_BUILD_ROOT/sbin/hwclock
%endif
ln -sf ../../sbin/hwclock $RPM_BUILD_ROOT/usr/sbin/hwclock
ln -sf ../../sbin/clock $RPM_BUILD_ROOT/usr/sbin/clock
ln -sf hwclock $RPM_BUILD_ROOT/sbin/clock

# move flock in /bin, required for udev
# logger is useful in initscripts while /usr isn't mounted as well
for p in flock logger; do
	mv $RPM_BUILD_ROOT{%{_bindir},/bin}/$p
	ln -sf ../../bin/$p $RPM_BUILD_ROOT%{_bindir}/$p
done

# remove stuff we don't want
rm -f $RPM_BUILD_ROOT%_mandir/man1/{line,newgrp,pg}.1*
rm -f $RPM_BUILD_ROOT%_bindir/{line,newgrp,pg}

# deprecated commands
for I in /usr/bin/chkdupexe \
	%{_bindir}/scriptreplay
	do
	rm -f $RPM_BUILD_ROOT$I
done

# deprecated man pages
for I in man1/chkdupexe.1
	do
	rm -rf $RPM_BUILD_ROOT%{_mandir}/${I}*
done

# we install getopt/getopt-*.{bash,tcsh} as doc files
# note: versions <=2.12 use path "%{_datadir}/misc/getopt/*"
chmod 644 getopt/getopt-*.{bash,tcsh}
rm -f ${RPM_BUILD_ROOT}%{_datadir}/getopt/*
rmdir ${RPM_BUILD_ROOT}%{_datadir}/getopt

# /usr/sbin -> /sbin
for I in addpart delpart partx; do
	if [ -e $RPM_BUILD_ROOT/usr/sbin/$I ]; then
		mv $RPM_BUILD_ROOT/usr/sbin/$I $RPM_BUILD_ROOT/sbin/$I
	fi
done

# /usr/bin -> /bin
for I in taskset raw; do
	if [ -e $RPM_BUILD_ROOT/usr/bin/$I ]; then
		mv $RPM_BUILD_ROOT/usr/bin/$I $RPM_BUILD_ROOT/bin/$I
	fi
done

%find_lang %name

%clean
rm -rf $RPM_BUILD_ROOT

%post
%_install_info ipc.info
%ifarch ppc
ISCHRP=`grep CHRP /proc/cpuinfo`
if [ -z "$ISCHRP" ]; then
  ln -sf /sbin/clock-ppc /sbin/hwclock
fi
%endif

%preun
%_remove_install_info ipc.info

%files -f %name.lang
%defattr(-,root,root)
%doc */README.* NEWS AUTHORS
%doc getopt/getopt-*.{bash,tcsh}

/bin/arch
/bin/dmesg
%attr(755,root,root)	/bin/login
/bin/more
/bin/kill
/bin/taskset
%if %{include_raw}
/bin/raw
%config %{_sysconfdir}/udev/rules.d/60-raw.rules
%endif

%config(noreplace) %{_sysconfdir}/pam.d/chfn
%config(noreplace) %{_sysconfdir}/pam.d/chsh
%config(noreplace) %{_sysconfdir}/pam.d/login
%config(noreplace) %{_sysconfdir}/pam.d/remote

/sbin/agetty
/sbin/blockdev
/sbin/pivot_root
%ifnarch s390 s390x
/sbin/clock
%{_sbindir}/clock
%endif
/sbin/ctrlaltdel
/sbin/fdisk
/sbin/addpart
/sbin/delpart
/sbin/partx
%{_mandir}/man8/partx.8*
%{_mandir}/man8/addpart.8*
%{_mandir}/man8/delpart.8*

%ifarch %ix86 alpha ia64 x86_64 s390 s390x ppc ppc64 %{sunsparc}
/sbin/fsck.minix
/sbin/mkfs.minix
/sbin/mkfs.bfs
/sbin/fsck.cramfs
/sbin/mkfs.cramfs
%{_mandir}/man8/fsck.minix.8*
%{_mandir}/man8/mkfs.minix.8*
%{_mandir}/man8/mkfs.bfs.8*
%endif

%ifarch %ix86 alpha ia64 x86_64 s390 s390x ppc ppc64 %{sunsparc}
/sbin/sfdisk

%{_mandir}/man8/sfdisk.8*
%doc fdisk/sfdisk.examples
%endif

%ifnarch s390 s390x
/sbin/hwclock
/usr/sbin/hwclock
%endif
%ifarch ppc
/sbin/clock-ppc
/sbin/clock-rs6k
%endif
/sbin/mkfs
/sbin/mkswap
#/sbin/mkfs.bfs
/sbin/nologin
%{_mandir}/man8/nologin.8*

%{_bindir}/chrt
%{_bindir}/ionice

%{_bindir}/cal
%attr(4711,root,root)	%{_bindir}/chfn
%attr(4711,root,root)	%{_bindir}/chsh
%{_bindir}/col
%{_bindir}/colcrt
%{_bindir}/colrm
%{_bindir}/column
%ifarch %ix86 alpha armv4l ppc ppc64 %{sunsparc} x86_64
%{_bindir}/cytune
%{_mandir}/man8/cytune.8*
%endif
%{_bindir}/ddate
%{_bindir}/fdformat
/bin/flock
%{_bindir}/flock
%{_bindir}/getopt
%{_bindir}/hexdump
%{_bindir}/ipcrm
%{_bindir}/ipcs
%{_bindir}/isosize
%{_mandir}/man8/isosize.8*
/bin/logger
%{_bindir}/logger
%{_bindir}/look
%{_bindir}/mcookie
%{_bindir}/namei
%{_bindir}/rename
%{_bindir}/renice
%{_bindir}/rev
%{_bindir}/script
%{_bindir}/setsid
%{_bindir}/setterm
%ifarch %{sunsparc}
%{_bindir}/sunhostid
%endif
#%{_bindir}/tsort
%{_bindir}/tailf
%{_bindir}/ul
%{_bindir}/whereis
%attr(2755,root,tty)	%{_bindir}/write

%{_sbindir}/cfdisk
%{_mandir}/man8/cfdisk.8*

%ifarch %ix86
%{_sbindir}/rdev
%{_sbindir}/ramsize
%{_sbindir}/rootflags
%{_sbindir}/vidmode
%{_mandir}/man8/rdev.8*
%{_mandir}/man8/ramsize.8*
%{_mandir}/man8/rootflags.8*
%{_mandir}/man8/vidmode.8*
%endif
%{_sbindir}/readprofile
%ifnarch s390
%{_sbindir}/tunelp
%endif
%{_sbindir}/vipw
%{_sbindir}/vigr

%_infodir/ipc.info*

%{_mandir}/man1/arch.1*
%{_mandir}/man1/cal.1*
%{_mandir}/man1/chfn.1*
%{_mandir}/man1/chsh.1*
%{_mandir}/man1/col.1*
%{_mandir}/man1/colcrt.1*
%{_mandir}/man1/colrm.1*
%{_mandir}/man1/column.1*
%{_mandir}/man1/ddate.1*
%{_mandir}/man1/flock.1*
%{_mandir}/man1/getopt.1*
%{_mandir}/man1/hexdump.1*
#%{_mandir}/man1/hostid.1*
%{_mandir}/man1/kill.1*
%{_mandir}/man1/logger.1*
%{_mandir}/man1/login.1*
%{_mandir}/man1/look.1*
%{_mandir}/man1/mcookie.1*
%{_mandir}/man1/more.1*
%{_mandir}/man1/namei.1*
%{_mandir}/man1/readprofile.1*
%{_mandir}/man1/rename.1*
%{_mandir}/man1/rev.1*
%{_mandir}/man1/script.1*
%{_mandir}/man1/setterm.1*
#%{_mandir}/man1/tsort.1*
%{_mandir}/man1/tailf.1*
%{_mandir}/man1/ul.1*
%{_mandir}/man1/whereis.1*
%{_mandir}/man1/write.1*

%{_mandir}/man1/chrt.1*
%{_mandir}/man1/ionice.1*
%{_mandir}/man1/taskset.1*

%{_mandir}/man8/agetty.8*
%{_mandir}/man8/blockdev.8*
%{_mandir}/man8/ctrlaltdel.8*
%{_mandir}/man8/dmesg.8*
%{_mandir}/man8/fdformat.8*
%{_mandir}/man8/fdisk.8*
%ifnarch s390 s390x
%{_mandir}/man8/hwclock.8*
%endif
%{_mandir}/man8/ipcrm.8*
%{_mandir}/man8/ipcs.8*
%{_mandir}/man8/mkfs.8*
#%{_mandir}/man8/mkfs.bfs.8*
%{_mandir}/man8/mkswap.8*
%{_mandir}/man8/pivot_root.8*
%if %{include_raw}
%{_mandir}/man8/raw.8*
%{_mandir}/man8/rawdevices.8*
%endif
%{_mandir}/man8/renice.8*
%{_mandir}/man8/setsid.8*
%{_mandir}/man8/tunelp.8*
%{_mandir}/man8/vigr.8*
%{_mandir}/man8/vipw.8*

%files -n mount
%defattr(-,root,root)
%doc mount/README.mount
%attr(4755,root,root)	/bin/mount
%attr(4755,root,root)	/bin/umount
/sbin/swapon
/sbin/swapoff
%{_mandir}/man5/fstab.5*
%{_mandir}/man8/mount.8*
%{_mandir}/man8/swapoff.8*
%{_mandir}/man8/swapon.8*
%{_mandir}/man8/umount.8*

%files -n losetup
%defattr(-,root,root)
%{_mandir}/man8/losetup.8*
/sbin/losetup




%changelog
* Sat Aug 11 2007 Olivier Blin <oblin@mandriva.com> 2.13-0.pre7.6mdv2008.0
+ Revision: 61964
- fix uuid support in mkswap (upstream patch from util-linux-ng)

* Fri Aug 10 2007 Olivier Blin <oblin@mandriva.com> 2.13-0.pre7.5mdv2008.0
+ Revision: 61562
- rediff loop-AES related patches (#32263)
- disable losetup -a and -r patches (already in loop-AES patch)
- drop gzloop patch (we don't have kernel support anymore)
- restore dropped crypto patches
- add support of relatime option in mount

  + Thierry Vignaud <tvignaud@mandriva.com>
    - enable audit support

  + Christiaan Welvaart <spturtle@mandriva.org>
    - fix install of clock-ppc, shouldn't depend on build dir name

* Thu Aug 02 2007 Olivier Blin <oblin@mandriva.com> 2.13-0.pre7.3mdv2008.0
+ Revision: 58161
- obsolete and provide schedutils (merged in 2.13-pre1)

* Thu Aug 02 2007 Olivier Blin <oblin@mandriva.com> 2.13-0.pre7.2mdv2008.0
+ Revision: 57981
- buildrequires e2fsprogs-devel
- buildrequire gettext-devel
- pray and upload (Titi approved)
- add pam config file for remote login
- remove manual pivot_root installation, it's handled by autotools
- use a configure option to disable wall
- add some (59!) patches from Fedora (quickly reviewed, but if it's good for them, it's good for us)
- remove loop-AES, gzloop and most other crypto patches (not really working/used according to Pixel)
- replace CVE-2007-0822 with Fedora's version
- replace our cal width patch with Fedora's version
- add partx/addpart/delpart doc (from Fedora)
- replace our execl patch with Fedora's version
- replace our utmp fixes with Fedora's timeval patch
- sync pam files with Fedora
- remove large file patch, useless since we now build with _FILE_OFFSET_BITS=64
- remove custom mkcramfs build and drop mkcramfs binary (use mkfs.cramfs instead)
- use procpartitions patch from Fedora
- remove s390 patches
- merge kudzu and managed patch (like Fedora)
- remove separated cramfs1.1 (already in upstream package)
- add cramfs fixes from Fedora package
- remove gecossize patch (RH dropped it 3 years ago)
- remove unapplied patches from spec
- remove build fixes patch, O_LARGEFILE is defined in bits/fcntl.h
- remove swapon/swapoff label patch (handled upstream as of 2.12n)
- use Fedora patch for swapon symlink check (which is correctly located in is_in_proc_swaps() function)
- remove patches checking /proc/swaps for swapon/swapoff, already implemented upstream as of 2.11s
- update loop-AES patch, rediff it, and renumber it
- add taskset, chrt and ionice
- move addpart/delpart/partx in /sbin (from Fedora)
- do not install wall and scriptreplay
- update doc files list
- merge raw stuff with Fedora
- remove nfs man pages
- elvtune has been removed upstream
- sln has been removed upstream
- setfdprm has been removed upstream
- add back arch command (from Fedora)
- rebuild autotools stuff and add patch to fix MKINSTALLDIRS (from Fedora)
- enable login-utils, kill, write, and rdev
- use prefix trick from Fedora to avoid installing in /usr/usr
- install getopt/getopt-*.{bash,tcsh} as doc files (like Fedora)
- remove kbdrate (to be moved in a new kbd package)
- rescuept has been removed (this will break diskdrake's "rescue partition table" feature)
- adapt partx build to autotools
- remove merged linux/compiler.h hacks
- rework cdextra patch to use autotools
- add ocfs2 patch (from Fedora)
- add mount sloppy patch for external mount.nfs(4) calls (from Fedora)
- use new uhelper patch from Fedora
- remove fortify fixes, since NFS code has been dropped
- sync NFS patches with Fedora to use nfs-utils commands in mount/unmount
- drop user label umount patch, implemented upstream
- drop mount 2gb patch, we now define _FILE_OFFSET_BITS=64 by default
- drop llseek syscall patch, plain lseek() is now used
- drop more termcap patch (use ncurses only, like Fedora)
- remove HAVE_PIVOT_ROOT define, this is done by configure
- move cflags in make_cflags macro (and define _FILE_OFFSET_BITS=64)
- replace nonroot patch with configure and preprocessor options (like Fedora)
- replace "no chkdupexe" patch by rm commands (like Fedora)
- remove mdk conf patch, util-linux now uses autotools
- 2.13-pre7
- make fdisk reread partition table on block devices only (from pterjan)

  + Frederic Crozat <fcrozat@mandriva.com>
    - Update source1 : call ConsoleKit pam module and add a dependency on it

* Wed Jun 27 2007 Andreas Hasenack <andreas@mandriva.com> 2.12r-15mdv2008.0
+ Revision: 45105
- using serverbuild macro (-fstack-protector-all)

* Tue Jun 19 2007 Olivier Blin <oblin@mandriva.com> 2.12r-14mdv2008.0
+ Revision: 41419
- rebuild for new slang

* Wed May 09 2007 Olivier Blin <oblin@mandriva.com> 2.12r-13mdv2008.0
+ Revision: 25684
- do not include asm/kbio.h (from Per Oyvind Karlsen, #30624)
- use bunzipped patches (fix wrong srpm2svn.sh import)
- include sfdisk and cfdisk on sparc too (from Per Oyvind Karlsen, #30623)


* Wed Mar 21 2007 Andreas Hasenack <andreas@mandriva.com> 2.12r-12mdv2007.1
+ Revision: 147255
- fix for CVE-2007-0822 vulnerability, imported from
  2007.0 official updates

* Fri Mar 09 2007 Olivier Blin <oblin@mandriva.com> 2.12r-11mdv2007.1
+ Revision: 139439
- fix buffer overflow in cal (rediffed patch from Pablo, #29311)

* Wed Feb 21 2007 Frederic Crozat <fcrozat@mandriva.com> 2.12r-10mdv2007.1
+ Revision: 123886
-Remove antique obsolete (special dedicace to dadou)
-Patch225 (Fedora): add support for umount helper (Mdv bug #24692)

  + Gwenole Beauchesne <gbeauchesne@mandriva.com>
    - merge in ppc64 fixes

  + Olivier Blin <oblin@mandriva.com>
    - Import util-linux

* Fri Jun 30 2006 Per Øyvind Karlsen <pkarlsen@mandriva.com> 2.12r-8mdv2007.0
- fix sparc build (P1212)
- use %%{sunsparc} macro
- no sfdisk & cfdisk on sparc
- fix prereq-use
- add requires on info-install and use it at correct time (%%preun in stead of %%postun)
- fix macro-in-%%changelog

* Sat Jun 24 2006 Frederic Crozat <fcrozat@mandriva.com> 2.12r-7mdv2007.0
- Update patch218 to refresh non handled options list for various fs (Mdv bug #23264)
- Remove patch 225, merged into patch 218

* Wed May 24 2006 Olivier Blin <oblin@mandriva.com> 2.12r-6mdk
- move logger in /bin, for initscripts

* Fri Apr 07 2006 Olivier Blin <oblin@mandriva.com> 2.12r-5mdk
- move flock in /bin, required for udev

* Mon Jan 30 2006 Olivier Blin <oblin@mandriva.com> 2.12r-4mdk
- use "include" directive instead of deprecated pam_stack in pam.d
  configuration files (and strip modules path)
- use URL of an up-to-date mirror

* Fri Jan 06 2006 Oden Eriksson <oeriksson@mandriva.com> 2.12r-3mdk
- drop selinux support

* Mon Dec 26 2005 Olivier Blin <oblin@mandriva.com> 2.12r-2mdk
- Patch1211: don't fail in "swapon -a" when using labels and -e option

* Sat Oct 08 2005 Olivier Blin <oblin@mandriva.com> 2.12r-1mdk
- 2.12r
- remove Patch1400 (merged upstream)

* Wed Sep 21 2005 Olivier Blin <oblin@mandriva.com> 2.12q-7mdk
- Patch1400 (Vincent Danen): security fix for CAN-2005-2876
  (don't allow umount -r when not root)

* Mon Sep 19 2005 Olivier Blin <oblin@mandriva.com> 2.12q-6mdk
- Patch218:
  o really ignore utf8 option if fs doesn't handle it
  o udf do support utf8
  o allow to remove conflicting options
    (for example utf8 if fs is udf and iocharset is specified)

* Sat Aug 27 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.12q-5mdk
- fortify fixes
- honor "mode=" for devpts filesystems (#16269, LSB, Stew)

* Wed Aug 24 2005 Gwenole Beauchesne <gbeauchesne@mandriva.com> 2.12q-4mdk
- varargs fixes

* Fri May 13 2005 Olivier Blin <oblin@mandriva.com> 2.12q-3mdk
- only keep utf8 option for iso9660, ntfs and vfat (update patch 218)

* Thu May 05 2005 Arnaud Patard <apatard@mandriva.com> 2.12q-2mdk
- Fix a patch that was badly applying. This was causing in a double close in 
  some cases.

* Sat Apr 30 2005 Arnaud Patard <apatard@mandriva.com> 2.12q-1mdk
- New upstream version
- Rediff patches : 0,106,115,116,121,204,207,209,211,214,215,221,1208,1300
- Updated patch : 213
- Drop the limitation on partition number. This one was preventing to have more
  than 16 partitions on ide devices.
- Added a patch for guessing if a cd is a cd-extra or not.
- Updated nfs mount version to the kernel version
- Dropped the retryudp patch as the mount program relies now on the portmap informations

* Fri Mar 04 2005 Pixel <pixel@mandrakesoft.com> 2.12a-12mdk
- sfdisk warnings must not be on stdout, otherwise they get in the way when restoring

* Mon Feb 14 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 2.12a-11mdk 
- Patch221 (Fedora): add support for "pamconsole"
- Patch222 (Fedora): add support for "managed"

* Fri Jan 21 2005 Gwenole Beauchesne <gbeauchesne@mandrakesoft.com> 2.12a-10mdk
- use glibc syscall() to use syscalls, ban use of <asm/unistd.h>

* Wed Jan 19 2005 Thierry Vignaud <tvignaud@mandrakesoft.com> 2.12a-9mdk
- patch 160: fix raw devices with udev (#11511)

* Sat Jan 08 2005 Olivier Blin <blino@mandrake.org> 2.12a-8mdk
- fix patch128, codepage option isn't supported by udf

* Wed Jan 05 2005 Pixel <pixel@mandrakesoft.com> 2.12a-7mdk
- in patch218: remove the realloc which causes some bug (on non malloc'ed pointers?)

* Tue Jan 04 2005 Pixel <pixel@mandrakesoft.com> 2.12a-6mdk
- rework Patch218: instead of black listing some options for some fs types,
  white list them
- fix Summary for losetup and mount (as requested by rpmlint)

* Fri Sep 17 2004 Olivier Blin <blino@mandrake.org> 2.12a-5mdk
- update Patch218: remove codepage option for udf
  (to be able to mount udf with magicdev)

* Wed Sep 08 2004 Olivier Blin <blino@mandrake.org> 2.12a-4mdk
- Patch1207: do not hide users option in mtab
  (so that kde can recognize partitions it can unmount)

* Fri Sep 03 2004 Olivier Blin <blino@mandrake.org> 2.12a-3mdk
- remove more silly options when mounting in "auto" fstype :
  codepage, iocharset and umask options can't be used with ext2 and ext3
  (useful to be able to mount fat and ext2/ext3 usb keys with the same options)
- Patch121: fix compilation issues

* Tue Jul 27 2004 Pixel <pixel@mandrakesoft.com> 2.12a-2mdk
- rebuild for new slang (as requested by Marcel Pol)

* Tue Jul 20 2004 Nicolas Planel <nplanel@mandrakesoft.com> 2.12a-1mdk
- 2.12a.
- enable selinux option.
- load cryptoapi and cypher modules when use cryptoapi (220).

* Fri Jul 16 2004 Pixel <pixel@mandrakesoft.com> 2.12-7mdk
- fix unstripped-binary-or-object and non-standard-executable-perm for /sbin/{addpart,delpart,kbdrate,partx}

* Fri Jul 16 2004 Pixel <pixel@mandrakesoft.com> 2.12-5mdk
- add Mandrakemove losetup patches:
  - try LOOP_CHANGE_FD when loop already busy
  - handle gzloop pseudo encryption

* Fri Jul 16 2004 Pixel <pixel@mandrakesoft.com> 2.12-4mdk
- change LOOP_PASSWORD_MIN_LENGTH from 20 to 3
(drakloop and diskdrake will ensure 6 or maybe 8 long passwords, but 20 is much too long)

* Sat Apr 24 2004 Nicolas Planel <nplanel@mandrakesoft.com> 2.12-3mdk
- chfn/chsh unckecked pam return error (vdanen).

